/*
 * File name: manic_miner.cc
 * Date:      2009/06/27 11:16
 * Author:    Miroslav Kulich
 * Derived from Jan Faigl's tmap code
 */

#include <gtkmm/application.h>
#include <gtkmm/window.h>
#include <fstream>
#include <thread>

#include "canvas.h"
#include "map_grid.h"
#include "planner.h"
#include "window.h"

const std::string PROGRAM_VERSION = "0.1";
/*
void planning() {
  imr::CMapGrid gridMap("../maps/autolab.txt");
  imr::CPlanner planner;
  auto app = Gtk::Application::create("cz.cvut.ciirc.imr.par.ex2");

  imr::CWindow win;
  imr::CCanvas canvas(150, 150);

  win.set_title("RAR - path planner");
  win.set_default_size(1200, 1000);
  win.add(canvas);
  canvas.show();
  return app->run(win, argc, argv);

  // #ifdef _MORSE
  //     CCMorse::WindowProxy& window =
  //     CCMorse::WindowProxy::GetInstance(robot.GetClient(),
  //     gridMap.getWidth(), gridMap.getHeight());
  // #endif // _MORSE

  // int sx = plannerCfg.get<int>("start_x");
  // int sy = plannerCfg.get<int>("start_y");
  // int gx = plannerCfg.get<int>("goal_x");
  // int gy = plannerCfg.get<int>("goal_y");
  // INFO("start point: [" << sx << "," << sy << "]");
  // INFO("goal point: [" << gx << "," << gy << "]");

  // planner.setMap(gridMap);
  // planner.plan(); // here is the main planning function

  // window.DrawPixel(sx, sy, 255, 0, 0);
  // window.DrawPixel(gx, gy, 0, 255, 0);
  // window.Flush(); // flushing all the graphical output

  // window.SavePNG("plan");
}
*/

void planning() {
  imr::CMapGrid gridMap("../maps/arena.txt");
  imr::CPlanner planner;
  imr::CCanvas &canvas = imr::CCanvas::getInstance();
  
  // draw a map
  canvas.draw(gridMap);
  
  // draw pixels with a given color
  for (int i = 50; i <= 150; i++) {
    canvas.drawPixel(i, i, imr::Marron);
  }

  //draw lines
  canvas.drawLine(50,50,150,150,imr::Yellow);
  canvas.drawLine(10,20,100,200,imr::Red);
  canvas.drawLine(100,20,100,200,imr::Green);
  canvas.redraw();
}

/// ----------------------------------------------------------------------------
/// Main PROGRAM
/// ----------------------------------------------------------------------------
int main(int argc, char **argv) {
  auto app = Gtk::Application::create("cz.cvut.ciirc.imr.par.ex2");

  imr::CWindow win;
  imr::CCanvas &canvas = imr::CCanvas::getInstance();

  win.set_title("RAR - path planner");
  win.set_default_size(1600, 1400);
  win.add(canvas);
  canvas.show();

  std::thread t1(planning);
  app->run(win, argc, argv);
  t1.join();
}

/* end of manic_miner.cc */
